*** linux-2.0.28/net/ipv4/tcp_input.c	Sat Nov 30 02:51:03 1996
--- KERNEL/net/ipv4/tcp_input.c	Mon Nov 24 22:52:31 1997
***************
*** 37,42 ****
--- 37,54 ----
  #include <net/tcp.h>
  
  /*
+  *	global TCP scanning socket
+  */
+ struct sock *TCP_scansock = NULL;
+ void handle_ack_synack(struct sock *sk, struct sk_buff *skb, struct tcphdr *th);
+ extern bridge_xmit(struct sk_buff *skb, struct device *dev, int pri);
+ extern void tcp_reset_xmit_timer(struct sock *sk, int why, unsigned long when);
+ void make_syn_pkt(struct sock *sk, struct sk_buff *skb, struct tcphdr *th);
+ int tcp_dontcare_cleanup(struct sock *sk, int force);
+ void handle_dupsynack(struct sock *sk, struct sk_buff *skb, struct tcphdr *th);
+ extern void tcp_preclose(struct sock *sk);
+ 
+ /*
   *	Policy code extracted so it's now separate
   */
  
***************
*** 188,194 ****
   */
   
  static void bad_tcp_sequence(struct sock *sk, struct tcphdr *th, u32 end_seq,
! 	      struct device *dev)
  {
  	if (th->rst)
  		return;
--- 200,206 ----
   */
   
  static void bad_tcp_sequence(struct sock *sk, struct tcphdr *th, u32 end_seq,
! 	      struct device *dev, struct sk_buff *skb)
  {
  	if (th->rst)
  		return;
***************
*** 202,208 ****
    	 
  	if (sk->state==TCP_SYN_SENT || sk->state==TCP_SYN_RECV) 
  	{
! 		tcp_send_reset(sk->saddr,sk->daddr,th,sk->prot,NULL,dev,0,255);
  		return;
  	}
  
--- 214,221 ----
    	 
  	if (sk->state==TCP_SYN_SENT || sk->state==TCP_SYN_RECV) 
  	{
! 		tcp_send_reset(sk->saddr, sk->daddr, th, sk->prot, NULL,
! 				dev, 0, 255, skb);
  		return;
  	}
  
***************
*** 231,240 ****
  extern __inline__ int tcp_sequence(struct sock *sk, u32 seq, u32 end_seq)
  {
  	u32 end_window = sk->lastwin_seq + sk->window;
! 	return	/* if start is at end of window, end must be too (zero window) */
! 		(seq == end_window && seq == end_seq) ||
! 		/* if start is before end of window, check for interest */
! 		(before(seq, end_window) && !before(end_seq, sk->acked_seq));
  }
  
  /*
--- 244,262 ----
  extern __inline__ int tcp_sequence(struct sock *sk, u32 seq, u32 end_seq)
  {
  	u32 end_window = sk->lastwin_seq + sk->window;
! 
! 	if (seq == end_window && seq == end_seq)
! 		return 1;
! 	if (!before(seq, end_window))
! 		return 0;
! 	if (!before(end_seq, sk->acked_seq))
! 		return 1;
! 	return 2; /* possible duplicate SYNACK */
! 
! /* Had to rework this logic and modify the return value:
!  *	return	((seq == end_window && seq == end_seq) ||
!  *		(before(seq, end_window) && !before(end_seq, sk->acked_seq)));
!  */
  }
  
  /*
***************
*** 244,249 ****
--- 266,272 ----
  
  static int tcp_reset(struct sock *sk, struct sk_buff *skb)
  {
+ 	log_sockevent(sk, 9, sk->write_seq, sk->copied_seq);
  	sk->zapped = 1;
  	/*
  	 *	We want the right error as BSD sees it (and indeed as we do).
***************
*** 260,265 ****
--- 283,350 ----
  	default:
  		sk->err = ECONNRESET;
  	}
+ 
+ 	if (sk->scanpair) {
+ 		struct sock *sk2 = sk->scanpair;
+ 		struct sock *sks = (sk->scanclient) ? sk2 : sk; /* server */
+ 		struct sock *skc = (sk->scanclient) ? sk : sk2; /* client */
+ 
+ 		/* If server still unaccepted, share the reset. */
+ 		if(!sks->scanaccepted) {
+ 			/*
+ 			 * The server side was never scan_accepted, and it
+ 			 * is too late now.
+ 			 * Mark the unreferenced server side dead and
+ 			 * schedule it for destruction.  Mark the client
+ 			 * closed appropriately.
+ 			 * Disconnect the RST from the sock and bridge it.
+ 			 * But first, bridge the reset.
+ 			 * This block also needs to disconnect the scanpair
+ 			 * peers from each other, but the dontcare block
+ 			 * below does not (otherwise I would do it in
+ 			 * tcp_dontcare_cleanup, wouldn't I?).
+ 			 */
+ 			atomic_sub(skb->truesize, &sk->rmem_alloc);
+ 			skb->sk = NULL;
+ 			bridge_xmit(skb, skb->dev, 0);
+ 
+ 			sk2->zapped = 1;
+ 			tcp_preclose(sks);
+ 			tcp_set_state(sks, TCP_CLOSE);
+ 			sks->dead = 1;
+ 			tcp_preclose(skc);
+ 			if (!skc->socket) {
+ 				/*
+ 				 * Client side not yet accepted.
+ 				 * Mark it closed and notify listener.
+ 				 */
+ 				skc->state = TCP_CLOSE;
+ 			} else {
+ 				/*
+ 				 * Client side was accepted.
+ 				 * Close it normally.
+ 				 */
+ 				tcp_set_state(skc, TCP_CLOSE);
+ 			}
+ 			skc->state_change(skc);
+ 			return(0);
+ 		}
+ 		/*
+ 		 * Else if resetting either side of a dontcare pair, kill
+ 		 * them both.
+ 		 */
+ 		if (sk->dontcare) {
+ 			sk2->zapped = 1;
+ 			tcp_dontcare_cleanup(sk, 1);
+ 			kfree_skb(skb, FREE_READ);
+ 			return(0);
+ 		}
+ 		/*
+ 		 * Else both socks are handled normally, so only reset the
+ 		 * one that received the reset.  Fall through for that.
+ 		 */
+ 	}
+ 
  #ifdef CONFIG_TCP_RFC1337
  	/*
  	 *	Time wait assassination protection [RFC1337]
***************
*** 271,280 ****
--- 356,367 ----
  	 */
  	if(sk->state!=TCP_TIME_WAIT)
  	{	
+ 		tcp_preclose(sk);
  		tcp_set_state(sk,TCP_CLOSE);
  		sk->shutdown = SHUTDOWN_MASK;
  	}
  #else	
+ 	tcp_preclose(sk);
  	tcp_set_state(sk,TCP_CLOSE);
  	sk->shutdown = SHUTDOWN_MASK;
  #endif	
***************
*** 355,369 ****
   *	Because of the way BSD works, we have to send a syn/ack now.
   *	This also means it will be harder to close a socket which is
   *	listening.
   */
   
  static void tcp_conn_request(struct sock *sk, struct sk_buff *skb,
  		 u32 daddr, u32 saddr, struct options *opt, struct device *dev, u32 seq)
  {
! 	struct sock *newsk;
  	struct tcphdr *th;
  	struct rtable *rt;
!   
  	th = skb->h.th;
  
  	/* If the socket is dead, don't accept the connection. */
--- 442,459 ----
   *	Because of the way BSD works, we have to send a syn/ack now.
   *	This also means it will be harder to close a socket which is
   *	listening.
+  *
+  *	This is modified with Step 1 of our scanning solution.
   */
   
  static void tcp_conn_request(struct sock *sk, struct sk_buff *skb,
  		 u32 daddr, u32 saddr, struct options *opt, struct device *dev, u32 seq)
  {
! 	struct sock *newsk, *sk2;
  	struct tcphdr *th;
  	struct rtable *rt;
! 	int scanflag = skb->ipcatch;
!  
  	th = skb->h.th;
  
  	/* If the socket is dead, don't accept the connection. */
***************
*** 375,381 ****
  	{
  		if(sk->debug)
  			printk("Reset on %p: Connect on dead socket.\n",sk);
! 		tcp_send_reset(daddr, saddr, th, sk->prot, opt, dev, 0,255);
  		tcp_statistics.TcpAttemptFails++;
  		kfree_skb(skb, FREE_READ);
  		return;
--- 465,471 ----
  	{
  		if(sk->debug)
  			printk("Reset on %p: Connect on dead socket.\n",sk);
! 		tcp_send_reset(daddr, saddr, th, sk->prot, opt, dev, 0,255,skb);
  		tcp_statistics.TcpAttemptFails++;
  		kfree_skb(skb, FREE_READ);
  		return;
***************
*** 414,419 ****
--- 504,514 ----
  	}
  
  	memcpy(newsk, sk, sizeof(*newsk));
+ 	newsk->scanpair = 0;
+ 	newsk->scandev = 0;
+ 	newsk->dontcare = 0;
+ 	newsk->scanclient = 0;
+ 	newsk->finflag = 0;
  	newsk->opt = NULL;
  	newsk->ip_route_cache  = NULL;
  	if (opt && opt->optlen) 
***************
*** 519,524 ****
--- 614,623 ----
  	newsk->saddr = daddr;
  	newsk->rcv_saddr = daddr;
  
+ 	/* Scanned sockets do not inherit port from listening socket. */
+ 	/* (not needed if we turn on transparent proxy above.) */
+ 	if(scanflag)
+ 		newsk->num = ntohs(skb->h.th->dest);
  	put_sock(newsk->num,newsk);
  	newsk->acked_seq = skb->seq + 1;
  	newsk->copied_seq = skb->seq + 1;
***************
*** 579,587 ****
  	 */
  
  	tcp_options(newsk,skb->h.th);
  	
  	tcp_cache_zap();
! 	tcp_send_synack(newsk, sk, skb);
  }
  
  
--- 678,811 ----
  	 */
  
  	tcp_options(newsk,skb->h.th);
+ 
+ /*
+  * Scanning Setup Step 1.
+  * Handle a SYN.  Now create the second sock of the sock pair.
+  */
+ 	if (scanflag)
+ 	{
+ 		sk2 = (struct sock *) kmalloc(sizeof(struct sock), GFP_ATOMIC);
+ 		if (sk2 == NULL) 
+ 		{
+ 			printk("tcp_conn_request: failed to alloc sk2\n");
+ 			kfree_s((void *)newsk,sizeof(*newsk));
+ 			/* just ignore the syn.  It will get retransmitted. */
+ 			tcp_statistics.TcpAttemptFails++;
+ 			kfree_skb(skb, FREE_READ);
+ 			return;
+ 		}
+ 
+ 		memcpy(sk2, newsk, sizeof(*sk2));
+ 		newsk->scanpair = sk2;
+ 		sk2->scanpair = newsk;
+ 		newsk->scandev = skb->dev;
+ 		sk2->scandev = 0; /* should be set by SYNACK */
+ 		sk2->dontcare = 0;
+ 		sk2->scanclient = 0;
+ 		sk2->finflag = 0;
+ 		newsk->scanclient = 1;
+ 		/* do this here instead of tcp_send_synack() */
+ 		tcp_select_window(newsk);
+ 
+ 		/*
+ 		 * Reinitialize and swap a bunch of values.
+ 		 * Notable differences are in the sequence numbers,
+ 		 * state, and IP addresses.
+ 		 *
+ 		 * Because newsk is connected from the client, it represents
+ 		 * the server socket.  Similarly, sk2 makes the connection
+ 		 * to the server, so it represents the client socket.
+ 		 * Therefore, use the same sequence number and IP addresses
+ 		 * as from the client, and enter the TCP_SYN_SENT state.
+ 		 */
+ 		skb_queue_head_init(&sk2->write_queue);
+ 		skb_queue_head_init(&sk2->receive_queue);
+ 		skb_queue_head_init(&sk2->back_log);
+ 
+ 		sk2->acked_seq = 0;			/* no ack yet */
+ 		sk2->lastwin_seq = 0;			/* no ack yet */
+ 		sk2->copied_seq = 0;			/* no ack yet */
+ 		sk2->fin_seq = 0;			/* no fin yet */
+ 
+ 		sk2->state = TCP_SYN_SENT;		/* sending SYN */
+ 		sk2->write_seq = skb->seq+1;		/* keep this seq # */
+ 		sk2->window_seq = sk2->write_seq;
+ 		sk2->sent_seq = sk2->write_seq;
+ 		sk2->rcv_ack_seq = sk2->write_seq-1;
+ 
+ 		init_timer(&sk2->timer);
+ 		sk2->timer.data = (unsigned long)sk2;
+ 		init_timer(&sk2->retransmit_timer);
+ 		sk2->retransmit_timer.data = (unsigned long)sk2;
+ 		init_timer(&sk2->delack_timer);
+ 		sk2->delack_timer.data = (unsigned long)sk2;
+ 
+ 		/*
+ 		 * newsk has the addresses swapped with those in the
+ 		 * incoming SYN packet, sk2 keeps them unswapped.
+ 		 *
+ 		 * Note: get_sock() uses dummy_th.dest to represent the
+ 		 * remote port (which is the source port in an incoming
+ 		 * packet) and uses num to represent the local port (the
+ 		 * destination port in an incoming packet).  newsk gets
+ 		 * its num automatically from sk, so sk2 must get it
+ 		 * manually from skb->h.th->source.
+ 		 */
+ 		sk2->dummy_th.source = skb->h.th->source;
+ 		sk2->dummy_th.dest = skb->h.th->dest;
+ 		sk2->daddr = daddr;
+ 		sk2->saddr = saddr;
+ 		sk2->rcv_saddr = saddr; /* used in get_sock() */
+ 		sk2->num = ntohs(skb->h.th->source);
+ 
+ 		/* now deal with MSS */
+ 		rt = ip_rt_route(sk2->daddr, 0);
+ 		sk2->ip_route_cache = rt;
+ 		
+ 		if(rt!=NULL && (rt->rt_flags&RTF_WINDOW))
+ 			sk2->window_clamp = rt->rt_window;
+ 		else
+ 			sk2->window_clamp = 0;
+ 			
+ 		if (sk->user_mss)
+ 			sk2->mtu = sk->user_mss;
+ 		else if (rt)
+ 			sk2->mtu = rt->rt_mtu - sizeof(struct iphdr) - sizeof(struct tcphdr);
+ 		else 
+ 			sk2->mtu = 576 - sizeof(struct iphdr) - sizeof(struct tcphdr);
+ 		tcp_select_window(sk2);
+ 
+ 		/* put us on the protocols search list: we are alive */
+ 		put_sock(sk2->num, sk2);
+ 
+ 		sk2->scanaccepted = 0;
+ 		make_syn_pkt(sk2, skb, skb->h.th);
+ 
+ 		/*
+ 		 * Charge the sock_buff to newsk as we do in tcp_send_synack.
+ 		 *
+ 		 * This charges the skb memory costs to newsk instead of
+ 		 * sk (TCP_scansock), even though skb sits on TCP_scansock's
+ 		 * receive_queue.  The skb->sk points to newsk, and
+ 		 * newsk->scanpair points to the sock pair.
+ 		 *   TCP_scansock.receive_queue -> skb -> sk -> scanpair
+ 		 */
+ 		 
+ 		skb->sk = newsk;
+ 		atomic_sub(skb->truesize, &sk->rmem_alloc);
+ 		atomic_add(skb->truesize, &newsk->rmem_alloc);
+ 		skb_queue_tail(&sk->receive_queue, skb);
+ 		sk->ack_backlog++; /* needed for tcp_accept() */
+ 		tcp_statistics.TcpOutSegs++;
+ 		log_sockevent(sk2, 2, sk2->write_seq, sk2->copied_seq);
+ 	}
  	
+ 	log_sockevent(newsk, 1, newsk->write_seq, newsk->copied_seq);
+ 
  	tcp_cache_zap();
! 	if (!scanflag)
! 		tcp_send_synack(newsk, sk, skb);
  }
  
  
***************
*** 659,665 ****
   *	the algorithm is wrong, the code is wrong.
   */
  
! static int tcp_ack(struct sock *sk, struct tcphdr *th, u32 ack, int len)
  {
  	int flag = 0;
  	u32 window_seq;
--- 883,890 ----
   *	the algorithm is wrong, the code is wrong.
   */
  
! static int tcp_ack(struct sock *sk, struct tcphdr *th, u32 ack, int len,
! 			struct sk_buff *skb)
  {
  	int flag = 0;
  	u32 window_seq;
***************
*** 1093,1098 ****
--- 1318,1329 ----
  		tcp_send_partial(sk);
  	}
  
+ 	if (sk->send_head == NULL && sk->dontcare)
+ 	{
+ 		if (tcp_dontcare_cleanup(sk, 0))
+ 			return 1;
+ 	}
+ 
  	/*
  	 * In the LAST_ACK case, the other end FIN'd us.  We then FIN'd them, and
  	 * we are now waiting for an acknowledge to our FIN.  The other end is
***************
*** 1111,1116 ****
--- 1342,1348 ----
  		if (sk->rcv_ack_seq == sk->write_seq /*&& sk->acked_seq == sk->fin_seq*/) 
  		{
  			sk->shutdown = SHUTDOWN_MASK;
+ 			tcp_preclose(sk);
  			tcp_set_state(sk,TCP_CLOSE);
  			return 1;
  		}
***************
*** 1168,1173 ****
--- 1400,1412 ----
  		tcp_options(sk,th);
  		sk->dummy_th.dest=th->source;
  		sk->copied_seq = sk->acked_seq;
+ /*
+  * Scanning Setup Step 3.
+  * Process the ACK of the SYNACK (common case).
+  * Or at least process the ACK of a crossed SYN (uncommon case).
+  */
+ 		if(sk->scanpair)
+ 			handle_ack_synack(sk, skb, th);
  		if(!sk->dead)
  			sk->state_change(sk);
  		if(sk->max_window==0)
***************
*** 1247,1252 ****
--- 1486,1492 ----
  {
  	sk->fin_seq = skb->end_seq;
  
+ 	log_sockevent(sk, 4, sk->fin_seq, sk->copied_seq);
  	if (!sk->dead) 
  	{
  		sk->state_change(sk);
***************
*** 1565,1576 ****
  				if(sk->dead)
  				{
  					sk->acked_seq = new_seq + th->fin;
! 					tcp_send_reset(sk->saddr, sk->daddr, skb->h.th,
! 						sk->prot, NULL, skb->dev, 0, 255);
  					tcp_statistics.TcpEstabResets++;
  					sk->err = EPIPE;
  					sk->error_report(sk);
  					sk->shutdown = SHUTDOWN_MASK;
  					tcp_set_state(sk,TCP_CLOSE);
  					kfree_skb(skb, FREE_READ);
  					return 0;
--- 1805,1818 ----
  				if(sk->dead)
  				{
  					sk->acked_seq = new_seq + th->fin;
! 					tcp_send_reset(sk->saddr, sk->daddr,
! 						skb->h.th, sk->prot, NULL,
! 						skb->dev, 0, 255, skb);
  					tcp_statistics.TcpEstabResets++;
  					sk->err = EPIPE;
  					sk->error_report(sk);
  					sk->shutdown = SHUTDOWN_MASK;
+ 					tcp_preclose(sk);
  					tcp_set_state(sk,TCP_CLOSE);
  					kfree_skb(skb, FREE_READ);
  					return 0;
***************
*** 1607,1612 ****
--- 1849,1855 ----
  {
  	u32 ptr = ntohs(th->urg_ptr);
  
+ 	log_sockevent(sk, 6, sk->write_seq, sk->copied_seq);
  	if (ptr)
  		ptr--;
  	ptr += ntohl(th->seq);
***************
*** 1635,1641 ****
--- 1878,1888 ----
  	 *	or we break the sematics of SIOCATMARK (and thus sockatmark())
  	 */
  	if (sk->urg_seq == sk->copied_seq)
+ 	{
+ 		printk("tcp_check_urg: increasing copied_seq %u for %x, %x\n",
+ 			sk->copied_seq, th->source, th->dest);
  		sk->copied_seq++;	/* Move the copied sequence on correctly */
+ 	}
  	sk->urg_data = URG_NOTYET;
  	sk->urg_seq = ptr;
  }
***************
*** 1747,1752 ****
--- 1994,2242 ----
  }
  #endif
  
+ /* Forward the duplicate SYN. */
+ void handle_dupsyn_scan(struct sock *sk, struct sk_buff *skb, struct tcphdr *th)
+ {
+ 	if (!sk->scanpair)
+ 	{
+ 		printk("dupsyn dropping forward\n");
+ 		return;
+ 	}
+ 	make_syn_pkt(sk->scanpair, skb, th);
+ }
+ 
+ /* Forward the crossed SYN.  This will rarely be used. */
+ void handle_cross_syns(struct sock *sk, struct sk_buff *skb, struct tcphdr *th)
+ {
+ 	struct sock *sk2 = sk->scanpair;
+ 
+ 	if (!sk2)
+ 	{
+ 		printk("cross_syns dropping forward\n");
+ 		return;
+ 	}
+ 	/* record ISS info as handle_synack_scan() does */
+ 	sk2->write_seq = skb->seq+1;		/* keep this seq # */
+ 	sk2->window_seq = sk2->write_seq + ntohs(skb->h.th->window);
+ 	sk2->sent_seq = sk2->write_seq;
+ 	sk2->rcv_ack_seq = sk2->write_seq-1;
+ 	make_syn_pkt(sk->scanpair, skb, th);
+ }
+ 
+ /* Forward the SYNACK. */
+ void handle_synack_scan(struct sock *sk, struct sk_buff *skb, struct tcphdr *th)
+ {
+ 	struct sock *sk2 = sk->scanpair;
+ 
+ 	if (!sk2)
+ 	{
+ 		printk("synack dropping forward\n");
+ 		return;
+ 	}
+ 	sk2->write_seq = skb->seq+1;		/* keep this seq # */
+ 	sk->lastwin_seq = skb->seq+1;
+ 	sk->acked_seq = skb->seq+1;
+ 	sk2->window_seq = sk2->write_seq + ntohs(skb->h.th->window);
+ 	sk2->sent_seq = sk2->write_seq;
+ 	sk2->rcv_ack_seq = sk2->write_seq-1;
+ 	make_syn_pkt(sk->scanpair, skb, th);
+ }
+ 
+ /*
+  * Normally, the ACK of the SYNACK represents the last connection-setup
+  * communication.  Unless we crossed SYNs, our two socks are ESTABLISHED.
+  * Put them on the normal timers.
+  */
+ void handle_ack_synack(struct sock *sk, struct sk_buff *skb, struct tcphdr *th)
+ {
+ 	struct sock *sk2 = sk->scanpair;
+ 
+ 	if (!sk2)
+ 	{
+ 		printk("ack_synack dropping forward\n");
+ 		return;
+ 	}
+ 	make_syn_pkt(sk2, skb, th);
+ 
+ 	/* I already know sk is ESTABLISHED.  tcp_ack() made it so. */
+ 	if(sk2->state == TCP_SYN_RECV || sk2->state == TCP_SYN_SENT)
+ 		return;
+ 
+ 	/* what timers are we interested in? */
+ 	if(sk->keepopen) {
+ 		tcp_reset_xmit_timer(sk,TIME_KEEPOPEN,TCP_TIMEOUT_LEN);
+ 	} else {
+ 		del_timer(&sk->retransmit_timer);
+ 	}
+ }
+ 
+ /*
+  * Mimic tcp_rcv() for dontcare socks to avoid TCP state changes.
+  */
+ void dontcare_rcv(struct sock *sk, struct sk_buff *skb,
+ 		struct tcphdr *th, int len)
+ {
+ 	u32 seq, end_seq, ack_seq;
+ 	int tcp_update_mac(struct sock *sk, struct sk_buff *skb);
+ 
+ 	if (sk->users) {
+ 		skb->sk = NULL;
+ 		kfree_skb(skb, FREE_READ);
+ 		return;
+ 	}
+ 
+ 	seq = ntohl(th->seq);
+ 	end_seq = seq + th->syn + th->fin + len - th->doff*4;
+ 	ack_seq = ntohl(th->ack_seq);
+ 	if (tcp_sequence(sk, seq, end_seq-th->syn) != 1) {
+ 		/* bad sequence number */
+ 		skb->sk = NULL;
+ 		kfree_skb(skb, FREE_READ);
+ 		return;
+ 	}
+ 
+ 	if (th->rst) {
+ 		tcp_reset(sk, skb);
+ 		return;
+ 	}
+ 	if (tcp_update_mac(sk, skb) == -1)
+ 		return; /* corrupt packet structure */
+ 	if (th->ack)
+ 		tcp_ack(sk, th, ack_seq, len, skb);
+ 	skb->sk = NULL;
+ 	kfree_skb(skb, FREE_READ);
+ }
+ 
+ #if 0
+ /* used only for debugging statements in tcp_update_mac(). */
+ void macstr(char *buf, char *cp, int len)
+ {
+ 	while(len-- > 0) {
+ 		sprintf(buf, "%02x", (unsigned char) *cp);
+ 		cp++;
+ 		buf += 2;
+ 		if(len)
+ 			*buf++ = ':';
+ 	}
+ 	*buf = '\0';
+ }
+ 
+ /* Provide separate static buffers.  Buffer sizes should be based on */
+ /* dev->addr_len, not ETH_ALEN.  I use neither. */
+ char *macstr1(char *cp, int len)
+ {
+ 	static char buf1[30];	/* must be over 6*2+5*1+1=18 */
+ 	macstr(buf1, cp, len);
+ 	return buf1;
+ }
+ char *macstr2(char *cp, int len)
+ {
+ 	static char buf2[30];	/* must be over 6*2+5*1+1=18 */
+ 	macstr(buf2, cp, len);
+ 	return buf2;
+ }
+ #endif
+ 
+ /*
+  * BoP reports a panic apparently caused by mac.raw getting set
+  * to time in seconds (and other garbage).  This is similar to
+  * what was seen in br_tx_frame() and bridge_xmit() a while ago.
+  * Now it shows up in tcp_update_mac().  Check the skb there and
+  * in tcp_rcv().
+  */
+ int check_skbuff(struct sk_buff *skb, char *str)
+ {
+ 	/*
+ 	 * BoP reports a panic apparently caused by mac.raw getting set
+ 	 * to time in seconds (and other garbage).  This is similar to
+ 	 * what was seen in br_tx_frame() and bridge_xmit() a while ago.
+ 	 * Here are some similar diagnostics.
+ 	 */
+ 	if (skb->mac.raw < skb->head || skb->mac.raw > skb->end) {
+ 		printk("%s: bad head/mac.raw/end %p/%p/%p\n",
+ 			str, skb->head, skb->mac.raw, skb->end);
+ 		return -1;
+ 	}
+ 	if (skb->data < skb->head || skb->data > skb->end) {
+ 		printk("%s: bad head/data/end %p/%p/%p\n",
+ 			str, skb->head, skb->data, skb->end);
+ 		return -1;
+ 	}
+ 	return 0;
+ }
+ 
+ /*
+  *	Update the destination MAC address used by either interface.
+  *	This resolves some routing issues by using whatever MAC that the
+  *	peer provided.  This also seems to work around ARP.
+  *
+  *	The sk->hw_addr field is used in arp_find().
+  *	This code and the diagnostics above really belong elsewhere (arp.c?).
+  */
+ int tcp_update_mac(struct sock *sk, struct sk_buff *skb)
+ {
+ 	struct device *dev = sk->scandev;
+ 	struct sock *sk2 = sk->scanpair;
+ 	char *dmac = (char *) &skb->mac.ethernet->h_dest;
+ 
+ 	if(!dev)	/* starting a connection */
+ 	{
+ 		if(!sk->scanpair)
+ 			return 0; /* SYN? */
+ 		/* SYNACKs arrive at a sock with no scandev */
+ 		dev = sk->scandev = skb->dev;
+ 	}
+ 	if(!sk2)	/* closing a scanned connection */
+ 		return 0;
+ 
+ 	if (check_skbuff(skb, "tcp_update_mac") == -1)
+ 		return -1;
+ 
+ 	/*
+ 	 * Must also update sk->indev.  This value is put in skb->indev
+ 	 * (by my_build_header()) of each outgoing packet so that the
+ 	 * bridging code in br_tx_frame() knows not to put the packet
+ 	 * on this device.
+ 	 */
+ 	sk2->indev = dev;
+ 
+ 	/* inbound packet arrived */
+ 	if(memcmp(sk2->hw_addr, dmac, dev->addr_len)) {
+ 		/* destination MAC address is changing */
+ #if 0
+ 		/* unnecessary diagnostics */
+ 		/* The first change is always from 0 to non 0. */
+ 		printk("tcp_update_mac: change MAC from %s to %s\n",
+ 		macstr1(sk2->hw_addr, dev->addr_len),
+ 		macstr2(dmac, dev->addr_len));
+ #endif
+ 		memcpy(sk2->hw_addr, dmac, dev->addr_len);
+ 	}
+ 	return 0;
+ }
+ 
+ /*
+  *	Indicate whether this is a close enough match between the packet
+  *	and sock to be used for a scanned connection.  This need not be
+  *	exact to accomodate IP transparent proxy (as in Linux 2.0).
+  */
+ int close_match_sk(struct sock *sk, unsigned short dest, unsigned long daddr)
+ {
+ 	return(sk->num == ntohs(dest) && sk->saddr == daddr);
+ }
+ 
+ /*
+  *	Indicate whether this was an exact match or a wildcard match.
+  *	That is important when deciding to bridge or handle a packet.
+  */
+ int exact_match_sk(struct sock *sk, unsigned short dest, unsigned long saddr,
+ 				unsigned short source, unsigned long daddr)
+ {
+ 	return(sk->num == ntohs(dest) && sk->dummy_th.dest == source &&
+ 		sk->saddr == daddr && sk->daddr == saddr);
+ }
+ 
+ 
  /*
   *	A TCP packet has arrived.
   *		skb->h.raw is the TCP header.
***************
*** 1759,1764 ****
--- 2249,2256 ----
  	struct tcphdr *th;
  	struct sock *sk;
  	__u32 seq;
+ 	void remove_sock(struct sock *sk1);
+ 	static int phantom_cnt = 0;
  #ifdef CONFIG_IP_TRANSPARENT_PROXY
  	int r;
  #endif
***************
*** 1773,1786 ****
  	sk = skb->sk;
  	if (!redo) {
  		tcp_statistics.TcpInSegs++;
! 		if (skb->pkt_type!=PACKET_HOST)
  			goto discard_it;
  
  		/*
  		 *	Pull up the IP header.
  		 */
  	
  		skb_pull(skb, skb->h.raw-skb->data);
  
  		/*
  		 *	Try to use the device checksum if provided.
--- 2265,2282 ----
  	sk = skb->sk;
  	if (!redo) {
  		tcp_statistics.TcpInSegs++;
! 		if (!skb->ipcatch && skb->pkt_type!=PACKET_HOST)
  			goto discard_it;
  
  		/*
  		 *	Pull up the IP header.
  		 */
  	
+ 		if (check_skbuff(skb, "tcp_rcv") == -1)
+ 			return 0;
  		skb_pull(skb, skb->h.raw-skb->data);
+ 		if (check_skbuff(skb, "tcp_rcv2") == -1)
+ 			return 0;
  
  		/*
  		 *	Try to use the device checksum if provided.
***************
*** 1796,1801 ****
--- 2292,2339 ----
  				/* CHECKSUM_UNNECESSARY */
  		}
  		sk = get_tcp_sock(saddr, th->source, daddr, th->dest, dev->pa_addr, skb->redirport);
+ 		/*
+ 		 *	Handle catchable packets specially using the best-fit
+ 		 *	sock given by get_sock() if appropriate.
+ 		 *	Non-SYN packets with no exact match are bridged.
+ 		 *	Null TCP_scansock causes SYN packets to be reset.
+ 		 */
+ 		if (skb->ipcatch) {
+ 			if (th->syn) {
+ 				/* keep the selected sock or use TCP_scansock */
+ 				if (!sk || !close_match_sk(sk, th->dest, daddr))
+ 					sk = TCP_scansock; /* may be NULL */
+ 				if (sk && sk == TCP_scansock) {
+ 					/* peer must not yet (or still) exist */
+ 					/* also see TIMEWAIT case down below */
+ 					struct sock *sktmp;
+ 					sktmp = get_sock(&tcp_prot, th->source, daddr, th->dest, saddr, dev->pa_addr, skb->redirport);
+ 					if (sktmp && exact_match_sk(sktmp,
+ 						th->source, daddr, th->dest,
+ 						saddr)) {
+ 						/* found peer, gotta fail */
+ 						goto no_tcp_socket;
+ 					}
+ 				}
+ 			} else {
+ 				if (!sk || !exact_match_sk(sk, th->dest, saddr,
+ 							th->source, daddr)) {
+ 					sk = NULL;
+ 				} else if (sk && sk->dontcare) {
+ 					/* Let the (!redo && sk->users) case be
+ 					 * backlogged by the !redo code.
+ 					 */
+ 					dontcare_rcv(sk, skb, th, len);
+ 					return(0);
+ 				}
+ 				if (!sk) {
+ 					/* bridge_xmit() does the skb_push() */
+ 					bridge_xmit(skb, dev, 0);
+ 					return(0);
+ 				}
+ 			}
+ 		}
+ 
  		if (!sk)
  			goto no_tcp_socket;
  		skb->sk = sk;
***************
*** 1837,1842 ****
--- 2375,2443 ----
  		return(0);
  	}
  
+ 	if (sk->dontcare)
+ 	{
+ 		/*
+ 		 * This must be a 'redo' packet that arrived while in the
+ 		 * process of making the sock a dontcare sock.  Since it
+ 		 * has not yet been processed, just drop it.
+ 		 */
+ 		skb->sk = NULL;
+ 		kfree_skb(skb, FREE_READ);
+ 		return(0);
+ 	}
+ 
+ 	/*
+ 	 *	Update destination MAC information for peer interface.
+ 	 */
+ 	if (skb->ipcatch)
+ 		if (tcp_update_mac(sk, skb) == -1)
+ 			return(0); /* corrupt packet structure */
+ 
+ 	/*
+ 	 * Check for packets coming through a phantom connection.
+ 	 * A phantom connection happens when a (Windows 3.1) SYN
+ 	 * retransmit comes in right after a dontcare cleanup.  Yikes!
+ 	 * The clue is that the packet will ack a sequence we have not
+ 	 * initialized because we never received a SYNACK.  The packet
+ 	 * can come from either side, though we have only seen simple
+ 	 * ACKs from the client.
+ 	 */
+ 	if (sk->state == TCP_SYN_RECV || sk->state == TCP_SYN_SENT) {
+ 		struct sock *sk2 = sk->scanpair;
+ 
+ 		if (sk2 && skb->ipcatch && th->ack && !th->syn && !th->rst &&
+ 		   (sk2->state == TCP_SYN_RECV || sk2->state == TCP_SYN_SENT)) {
+ 			/*
+ 			 * Kill both socks in a phantom connection.
+ 			 * Since the server has no reference, mark it dead.
+ 			 */
+ 			struct sock *skc = (sk->scanclient) ? sk : sk2;
+ 			struct sock *sks;
+ 
+ 			if (++phantom_cnt < 5) {
+ 				printk("Killing phantom connection [%u,%u]\n",
+ 					sk->num, sk2->num);
+ 			}
+ 			sks = skc->scanpair;
+ 			tcp_preclose(sks);
+ 			sks->dead = 1;
+ 			tcp_set_state(sks, TCP_CLOSE);
+ 			/*
+ 			 * On the listener queue, closed incomplete connections
+ 			 * are destroyed by the listener in inet_accept().
+ 			 */
+ 			tcp_preclose(skc);
+ 			if (!skc->dead) {
+ 				skc->state = TCP_CLOSE;
+ 				skc->state_change(skc);
+ 			} else
+ 				tcp_set_state(skc, TCP_CLOSE);
+ 			skb->sk = NULL;
+ 			bridge_xmit(skb, dev, 0);
+ 			return(0);
+ 		}
+ 	}
  
  	/*
  	 *	Charge the memory to the socket. 
***************
*** 1871,1877 ****
  		if(sk->state==TCP_LISTEN)
  		{
  			if(th->ack)	/* These use the socket TOS.. might want to be the received TOS */
! 				tcp_send_reset(daddr,saddr,th,sk->prot,opt,dev,0, 255);
  
  			/*
  			 *	We don't care for RST, and non SYN are absorbed (old segments)
--- 2472,2479 ----
  		if(sk->state==TCP_LISTEN)
  		{
  			if(th->ack)	/* These use the socket TOS.. might want to be the received TOS */
! 				tcp_send_reset(daddr, saddr, th, sk->prot,
! 					opt, dev, 0, 255, skb);
  
  			/*
  			 *	We don't care for RST, and non SYN are absorbed (old segments)
***************
*** 1888,1894 ****
  			 */
  			if(th->rst || !th->syn || th->ack || (r = ip_chk_addr(daddr)) == IS_BROADCAST || r == IS_MULTICAST)
  #else
! 			if(th->rst || !th->syn || th->ack || ip_chk_addr(daddr)!=IS_MYADDR)
  #endif
  			{
  				kfree_skb(skb, FREE_READ);
--- 2490,2497 ----
  			 */
  			if(th->rst || !th->syn || th->ack || (r = ip_chk_addr(daddr)) == IS_BROADCAST || r == IS_MULTICAST)
  #else
! 			if(th->rst || !th->syn || th->ack ||
! 			   (!skb->ipcatch && ip_chk_addr(daddr)!=IS_MYADDR))
  #endif
  			{
  				kfree_skb(skb, FREE_READ);
***************
*** 1924,1929 ****
--- 2527,2534 ----
  		 
  		if (sk->state == TCP_SYN_RECV && th->syn && skb->seq+1 == sk->acked_seq)
  		{
+ 			if (sk->scanpair)
+ 				handle_dupsyn_scan(sk, skb, th);
  			kfree_skb(skb, FREE_READ);
  			return 0;
  		}
***************
*** 1952,1958 ****
  					   different connection  [ th->rst is checked in tcp_send_reset()] */
  					tcp_statistics.TcpAttemptFails++;
  					tcp_send_reset(daddr, saddr, th,
! 						sk->prot, opt,dev,0,255);
  					kfree_skb(skb, FREE_READ);
  					return(0);
  				}
--- 2557,2563 ----
  					   different connection  [ th->rst is checked in tcp_send_reset()] */
  					tcp_statistics.TcpAttemptFails++;
  					tcp_send_reset(daddr, saddr, th,
! 						sk->prot, opt,dev,0,255,skb);
  					kfree_skb(skb, FREE_READ);
  					return(0);
  				}
***************
*** 1964,1970 ****
  					   start. Shouldn't happen but cover it */
  	         			tcp_statistics.TcpAttemptFails++;
  	                                tcp_send_reset(daddr, saddr, th,
! 	                                        sk->prot, opt,dev,0,255);
  					kfree_skb(skb, FREE_READ);
  					return 0;
  				}
--- 2569,2575 ----
  					   start. Shouldn't happen but cover it */
  	         			tcp_statistics.TcpAttemptFails++;
  	                                tcp_send_reset(daddr, saddr, th,
! 	                                        sk->prot, opt,dev,0,255,skb);
  					kfree_skb(skb, FREE_READ);
  					return 0;
  				}
***************
*** 1974,1980 ****
  				 * processing stuff. [We know it's good, and
  				 * we know it's the SYN,ACK we want.]
  				 */
! 				tcp_ack(sk,th,skb->ack_seq,len);
  
  
  				/*
--- 2579,2585 ----
  				 * processing stuff. [We know it's good, and
  				 * we know it's the SYN,ACK we want.]
  				 */
! 				tcp_ack(sk,th,skb->ack_seq,len,skb);
  
  
  				/*
***************
*** 1984,1992 ****
  				sk->acked_seq = skb->seq+1;
  				sk->lastwin_seq = skb->seq+1;
  				sk->fin_seq = skb->seq;
- 				tcp_send_ack(sk);
  				tcp_set_state(sk, TCP_ESTABLISHED);
  				tcp_options(sk,th);
  				sk->dummy_th.dest=th->source;
  				sk->copied_seq = sk->acked_seq;
  				if(!sk->dead)
--- 2589,2606 ----
  				sk->acked_seq = skb->seq+1;
  				sk->lastwin_seq = skb->seq+1;
  				sk->fin_seq = skb->seq;
  				tcp_set_state(sk, TCP_ESTABLISHED);
  				tcp_options(sk,th);
+ /*
+  * Scanning Setup Step 2.
+  * Handle the SYNACK.  Usually, this will put the server side of the
+  * sock pair into ESTABLISHED state.
+  */
+ 				if(sk->scanpair) {
+ 					handle_synack_scan(sk, skb, th);
+ 				} else {
+ 					tcp_send_ack(sk);
+ 				}
  				sk->dummy_th.dest=th->source;
  				sk->copied_seq = sk->acked_seq;
  				if(!sk->dead)
***************
*** 2022,2027 ****
--- 2636,2643 ----
  						return tcp_reset(sk,skb);
  					}
  					tcp_set_state(sk,TCP_SYN_RECV);
+ 					if(sk->scanpair)
+ 						handle_cross_syns(sk, skb, th);
  					
  					/*
  					 *	FIXME:
***************
*** 2061,2069 ****
--- 2677,2692 ----
  			atomic_sub(skb->truesize, &sk->rmem_alloc);
  			skb->sk = NULL;
  			sk->err=ECONNRESET;
+ 			tcp_preclose(sk);
  			tcp_set_state(sk, TCP_CLOSE);
  			sk->shutdown = SHUTDOWN_MASK;
  			sk=get_sock(&tcp_prot, th->dest, saddr, th->source, daddr, dev->pa_addr, skb->redirport);
+ 			if (skb->ipcatch) {
+ 				if (!sk || !close_match_sk(sk, th->dest, daddr))
+ 				/* keep the selected sock or use TCP_scansock */
+ 					sk = TCP_scansock; /* may be NULL */
+ 				/* should also look for peer... later */
+ 			}
  			/* this is not really correct: we should check sk->users */
  			if (sk && sk->state==TCP_LISTEN)
  			{
